var asyncblock = require('./greenlight.js');

asyncblock(function(flow){
    console.time('t1');

    setTimeout(flow.add(), 1000);

    flow.wait();

    setTimeout(flow.add(), 2000);

    flow.wait();

    console.timeEnd('t1');
});

var immed = function(callback){
    callback();
};

asyncblock(function(flow){
    immed(flow.add());

    flow.wait();

    immed(flow.add());

    flow.wait();
});

var t2 = function(callback){
    process.nextTick(
        function(){
            callback(null, 't2');
        }
    );
};

asyncblock(function(flow){
    immed(flow.add());

    flow.wait();

    immed(flow.add());

    flow.wait();

    t2(flow.add());
    immed(flow.add());

    flow.wait();

    t2(flow.add());

    console.log(flow.wait());

    immed(flow.add('b'));

    console.log(flow.wait());
});

asyncblock(function(flow){
    t2(flow.add());

    console.log(flow.wait());

    t2(flow.add());

    console.log(flow.wait());
});

asyncblock(function(flow){
    t2(flow.add());

    console.log(flow.wait());
});

asyncblock(function(flow){
    t2(flow.add());
    t2(flow.add('t2'));
    t2(flow.add('t3'));

    console.log(flow.wait());

    immed(flow.add());
    immed(flow.add());
    t2(flow.add('t3'));

    console.log(flow.wait());
});

var t4 = function(flow, callback){
    process.nextTick(
        function(){
            t2(flow.add('t2'));

            callback(null, 't4');
        }
    );
};

asyncblock(function(flow){
    t4(flow, flow.add('t5'));

    console.log(flow.wait());
});